c*******************************************************************************
c	Start of the header for a fortran source file for a subroutine
c	of the Irwin pulsar epoch correction and precise radial velocity
c       barycentric code
c	Copyright (C) 1998 by Alan W. Irwin
c
c	$Id: fortran.header,v 2.3 1996/08/20 21:39:10 eos Exp $
c
c	For the latest version of this source code, please contact
c	Alan W. Irwin
c	Department of Physics and Astronomy
c	University of Victoria,
c	Box 3055
c	Victoria, B.C., Canada
c	V8W 3P6
c	e-mail: irwin@uvastro.phys.uvic.ca.
c
c    This program is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    This program is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program; if not, write to the Free Software
c    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c
c	End of the header for a fortran source file for a subroutine
c	of the Irwin epoch and barycentric correction code
c*******************************************************************************
      program asc_short
      implicit none
      integer*4 iblock, iblock_save, jblock,
     &  icoeff, ncoeff, ncoeff_save, maxncoeff, n3coeff,
     &  lnblnk, ifeof
      parameter(maxncoeff=3000)
      real*8 buf(2), t1, t2
      character*200 filename
      character*26 record(maxncoeff)
      write(0,*) 'Julian year range (two numbers in free format)?'
      read(*,*) t1,t2
      if(t2.le.t1) stop 'bad year range'
C       transform to jd
      t1 = 2451545.d0 + (t1-2000.d0)*365.25d0
      t2 = 2451545.d0 + (t2-2000.d0)*365.25d0
      write(0,*) 'ascii input file name (e.g., ''time_asc.405'')'
      read(*,'(a)') filename
      open(99, name=filename(:lnblnk(filename)), status='old')
      read(99,*,iostat=ifeof) iblock, ncoeff
      ncoeff_save = ncoeff
C       mod(ncoeff,3) , 2 - mod(ncoeff-1,3)
C       0               0
C       1               2
C       2               1
C       thus, n3coeff gives even number of triples
      n3coeff = ncoeff + 2 - mod(ncoeff-1,3)
      if(n3coeff.gt.maxncoeff) stop 'too many coefficients'
      iblock_save = 0
      buf(2) = 0.d0  !insure at least one loop
      jblock = 0
      do while(buf(2).le.t2.and.ifeof.eq.0)
        if(ncoeff.ne.ncoeff_save.or.iblock.ne.iblock_save+1)
     &    stop 'bad data file input'
        iblock_save = iblock
        read(99,'(3a)') (record(icoeff), icoeff = 1, n3coeff)
        read(record(1),'(d26.18)') buf(1)
        read(record(2),'(d26.18)') buf(2)
        if(
     &    (t1.le.buf(1).and.buf(1).le.t2).or.
     &    (t1.le.buf(2).and.buf(2).le.t2)
     &    ) then
          jblock = jblock + 1
          write(*,'(2i6)') jblock, ncoeff
          write(*,'(3a)') (record(icoeff), icoeff = 1, n3coeff)
        endif
        read(99,*,iostat=ifeof) iblock, ncoeff
      enddo
      end
